<?php 

namespace Teknisa\CNC\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;

use Teknisa\CNC\Services\Cnc01800ReconciliacaoService;

class Cnc01800Reconciliacao {
    
    protected $reconciliacaoService;
    
    public function __construct(Cnc01800ReconciliacaoService $reconciliacaoService) {
        $this->reconciliacaoService = $reconciliacaoService;
    }
    
    public function reconciliar (DTO\Request\Row $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $log = $this->reconciliacaoService->reconciliar($row);
            $response->addDataset(new DataSet('log', $log));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
    
    public function verifyDivergences (DTO\Request\Row $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $this->reconciliacaoService->verifyDivergences($row);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
}