<?php

namespace Teknisa\CNC\Factories;

use Doctrine\ORM\EntityManager;

class Cnc02700TaxaServEstabelecimentoFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function getEstabelecTaxaServ ($params) {
        $sql = "SELECT E.NRESTABELEC, E.CDESTABELEC, E.NMESTABELEC, E.VRPERCTXADMSERV, 
                   E.IDCTRLTXSERV, DECODE(E.IDCTRLTXSERV, 'S' , 'Sim', 'Não') NMCTRLTXSERV, E.CDTPAJUCTTXSRV, T.DSAJUCTREC DSTPAJUCTTXSRV, E.CDTPAJUCTTXADM, TA.DSAJUCTREC DSTPAJUCTTXADM 
                              FROM ESTABELECIMENTO E
                               LEFT JOIN TIPOAJRECEBER T
                                ON E.CDTPAJUCTTXSRV = T.CDAJUCTREC
                               LEFT JOIN TIPOAJRECEBER TA
                                ON E.CDTPAJUCTTXADM = TA.CDAJUCTREC
                             WHERE E.NRORG = :NRORG
                             ORDER BY  E.NRESTABELEC, E.CDESTABELEC, E.NMESTABELEC";     
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getEstabelecTaxaServRow ($params) {
        $sql = "SELECT E.NRESTABELEC, E.CDESTABELEC, E.NMESTABELEC, E.VRPERCTXADMSERV, 
                   E.IDCTRLTXSERV, E.CDTPAJUCTTXSRV, T.DSAJUCTREC DSTPAJUCTTXSRV, E.CDTPAJUCTTXADM, TA.DSAJUCTREC DSTPAJUCTTXADM 
                              FROM ESTABELECIMENTO E
                               LEFT JOIN TIPOAJRECEBER T
                                ON E.CDTPAJUCTTXSRV = T.CDAJUCTREC
                               LEFT JOIN TIPOAJRECEBER TA
                                ON E.CDTPAJUCTTXADM = TA.CDAJUCTREC
                             WHERE E.NRORG = :NRORG
                             AND E.NRESTABELEC = :NRESTABELEC
                             ORDER BY E.NRESTABELEC, E.CDESTABELEC, E.NMESTABELEC";     
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function gettpAjusteAdm ($params) {
        $sql = "SELECT CDAJUCTREC CDTPAJUCTTXADM, DSAJUCTREC DSTPAJUCTTXADM 
                    FROM TIPOAJRECEBER
                WHERE IDAJUCTREC = 'A'
                AND NRORG = :NRORG";        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function gettpAjustesServ ($params) {
        $sql = "SELECT CDAJUCTREC CDTPAJUCTTXSRV, DSAJUCTREC DSTPAJUCTTXSRV 
                    FROM TIPOAJRECEBER
                WHERE IDAJUCTREC = 'A'
                AND NRORG = :NRORG";        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function updateEstabelecTaxaServ($params) {
        $sql = "UPDATE ESTABELECIMENTO
                  SET IDCTRLTXSERV    = :IDCTRLTXSERV,
                      VRPERCTXADMSERV = :VRPERCTXADMSERV,
                      CDTPAJUCTTXADM  = :CDTPAJUCTTXADM,
                      CDTPAJUCTTXSRV  = :CDTPAJUCTTXSRV
                WHERE NRESTABELEC = :NRESTABELEC";
                  
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
}