<?php

namespace WebServiceCall\Repository\WS\Data;

use WebServiceCall\Log\WebServiceLogger as WSLog;

class SalesParams extends ASoapParams {
    private const SALES_URL = 'https://webservice.conciliadora.com.br/Services/Vendas.svc?wsdl';
    private const SALES_XML_X_PATH = '/Retorno/Vendas/Venda';
    private const SALES_SERVICE_NAME = 'ConsultaVenda';
    
    // @Override
    public function toArray() {
        return array(
            'idEmpresa' => $this->getIdEmpresa(),
            'senha' =>  $this->getPassword(),
            'dataVendaInicial' => $this->getDtIni(),
            'dataVendaFinal' => $this->getDtFim(),
        );
    }
    
    public function getXmlXPath() {
        return self::SALES_XML_X_PATH;
    }
    
    public function getServiceName() {
        return self::SALES_SERVICE_NAME;
    }
    
    public function getDatasetName() {
        return self::SALES_DATASET_NAME;
    }

    public function getURL() {
        return self::SALES_URL;
    }
    
    public function getResponseData($response) {
        return $response->ConsultaVendaResult;
    }
    
    public function getReportID() {
        return WSLog::SALES_REPORT_ID;
    }
}

